Loading...
Searching...
No Matches
pcl::visualization Namespace Reference

## Namespaces

namespace | context_items
namespace | details

## Classes

class | AreaPickingEvent
| /brief Class representing 3D area picking events. More...
class | Camera
| Camera class holds a set of camera parameters together with the window pos/size. More...
class | CloudActor
class | CloudViewer
| Simple point cloud visualization class. More...
struct | FEllipticArc2D
| Class for storing EllipticArc; every ellipse , circle are covered by this. More...
struct | Figure2D
| Abstract class for storing figure information. More...
class | FloatImageUtils
| Provide some general functionalities regarding 2d float arrays, e.g., for visualization purposes More...
struct | FPoints2D
| Class for storing Points. More...
struct | FPolygon2D
| Class for Polygon. More...
struct | FPolyLine2D
| Class for PolyLine. More...
struct | FQuad2D
| Class for storing Quads. More...
class | ImageViewer
| ImageViewer is a class for 2D image visualization. More...
class | ImageViewerInteractorStyle
| An image viewer interactor style, tailored for ImageViewer. More...
class | KeyboardEvent
| /brief Class representing key hit/release events More...
class | MouseEvent
struct | PCLContextImageItem
| Struct PCLContextImageItem a specification of vtkContextItem, used to add an image to the scene in the ImageViewer class. More...
struct | PCLContextItem
| Struct PCLContextItem represents our own custom version of vtkContextItem, used by the ImageViewer class. More...
class | PCLHistogramVisualizer
| PCL histogram visualizer main class. More...
class | PCLHistogramVisualizerInteractorStyle
| PCL histogram visualizer interactory style class. More...
class | PCLImageCanvasSource2D
| PCLImageCanvasSource2D represents our own custom version of vtkImageCanvasSource2D, used by the ImageViewer class. More...
class | PCLPainter2D
| PCL Painter2D main class. More...
class | PCLPlotter
| PCL Plotter main class. More...
class | PCLSimpleBufferVisualizer
| PCL simple buffer visualizer main class. More...
class | PCLVisualizer
| PCL Visualizer main class. More...
class | PCLVisualizerInteractorStyle
| PCLVisualizerInteractorStyle defines an unique, custom VTK based interactory style for PCL Visualizer applications. More...
class | PointCloudColorHandler
| Base Handler class for PointCloud colors. More...
class | PointCloudColorHandler< pcl::PCLPointCloud2 >
| Base Handler class for PointCloud colors. More...
class | PointCloudColorHandlerCustom
| Handler for predefined user colors. More...
class | PointCloudColorHandlerCustom< pcl::PCLPointCloud2 >
| Handler for predefined user colors. More...
class | PointCloudColorHandlerGenericField
| Generic field handler class for colors. More...
class | PointCloudColorHandlerGenericField< pcl::PCLPointCloud2 >
| Generic field handler class for colors. More...
class | PointCloudColorHandlerHSVField
| HSV handler class for colors. More...
class | PointCloudColorHandlerHSVField< pcl::PCLPointCloud2 >
| HSV handler class for colors. More...
class | PointCloudColorHandlerLabelField
| Label field handler class for colors. More...
class | PointCloudColorHandlerLabelField< pcl::PCLPointCloud2 >
| Label field handler class for colors. More...
class | PointCloudColorHandlerRandom
| Handler for random PointCloud colors (i.e., R, G, B will be randomly chosen) More...
class | PointCloudColorHandlerRandom< pcl::PCLPointCloud2 >
| Handler for random PointCloud colors (i.e., R, G, B will be randomly chosen) More...
class | PointCloudColorHandlerRGBAField
| RGBA handler class for colors. More...
class | PointCloudColorHandlerRGBAField< pcl::PCLPointCloud2 >
| RGBA handler class for colors. More...
class | PointCloudColorHandlerRGBField
| RGB handler class for colors. More...
class | PointCloudColorHandlerRGBField< pcl::PCLPointCloud2 >
| RGB handler class for colors. More...
class | PointCloudColorHandlerRGBHack
class | PointCloudGeometryHandler
| Base handler class for PointCloud geometry. More...
class | PointCloudGeometryHandler< pcl::PCLPointCloud2 >
| Base handler class for PointCloud geometry. More...
class | PointCloudGeometryHandlerCustom
| Custom handler class for PointCloud geometry. More...
class | PointCloudGeometryHandlerCustom< pcl::PCLPointCloud2 >
| Custom handler class for PointCloud geometry. More...
class | PointCloudGeometryHandlerSurfaceNormal
| Surface normal handler class for PointCloud geometry. More...
class | PointCloudGeometryHandlerSurfaceNormal< pcl::PCLPointCloud2 >
| Surface normal handler class for PointCloud geometry. More...
class | PointCloudGeometryHandlerXYZ
| XYZ handler class for PointCloud geometry. More...
class | PointCloudGeometryHandlerXYZ< pcl::PCLPointCloud2 >
| XYZ handler class for PointCloud geometry. More...
class | PointPickingCallback
class | PointPickingEvent
| /brief Class representing 3D point picking events. More...
class | RangeImageVisualizer
| Range image visualizer class. More...
class | RenWinInteract
class | Window

## Typedefs

using | CloudActorMap = std::unordered_map< std::string, CloudActor >
using | CloudActorMapPtr = shared_ptr< CloudActorMap >
using | ShapeActorMap = std::unordered_map< std::string, vtkSmartPointer< vtkProp > >
using | ShapeActorMapPtr = shared_ptr< ShapeActorMap >
using | CoordinateActorMap = std::unordered_map< std::string, vtkSmartPointer< vtkProp > >
using | CoordinateActorMapPtr = shared_ptr< CoordinateActorMap >
using | RenWinInteractMap = std::map< std::string, RenWinInteract >
using | Vector3ub = Eigen::Array< unsigned char, 3, 1 >

## Enumerations

enum | FrustumCull { PCL_INSIDE_FRUSTUM , PCL_INTERSECT_FRUSTUM , PCL_OUTSIDE_FRUSTUM }
enum | RenderingProperties { PCL_VISUALIZER_POINT_SIZE , PCL_VISUALIZER_OPACITY , PCL_VISUALIZER_LINE_WIDTH , PCL_VISUALIZER_FONT_SIZE , PCL_VISUALIZER_COLOR , PCL_VISUALIZER_REPRESENTATION , PCL_VISUALIZER_IMMEDIATE_RENDERING , PCL_VISUALIZER_SHADING , PCL_VISUALIZER_LUT , PCL_VISUALIZER_LUT_RANGE }
| Set of rendering properties. More...
enum | RenderingRepresentationProperties { PCL_VISUALIZER_REPRESENTATION_POINTS , PCL_VISUALIZER_REPRESENTATION_WIREFRAME , PCL_VISUALIZER_REPRESENTATION_SURFACE }
enum | ShadingRepresentationProperties { PCL_VISUALIZER_SHADING_FLAT , PCL_VISUALIZER_SHADING_GOURAUD , PCL_VISUALIZER_SHADING_PHONG }
enum | LookUpTableRepresentationProperties { PCL_VISUALIZER_LUT_JET , PCL_VISUALIZER_LUT_JET_INVERSE , PCL_VISUALIZER_LUT_HSV , PCL_VISUALIZER_LUT_HSV_INVERSE , PCL_VISUALIZER_LUT_GREY , PCL_VISUALIZER_LUT_BLUE2RED , PCL_VISUALIZER_LUT_RANGE_AUTO , PCL_VISUALIZER_LUT_VIRIDIS }
enum | InteractorKeyboardModifier { INTERACTOR_KB_MOD_ALT , INTERACTOR_KB_MOD_CTRL , INTERACTOR_KB_MOD_SHIFT }
| A list of potential keyboard modifiers for pcl::visualization::PCLVisualizerInteractorStyle::PCLVisualizerInteractorStyle() Defaults to Alt. More...

## Functions

PCL_EXPORTS void | getRandomColors (double &r, double &g, double &b, double min=0.2, double max=2.8)
| Get (good) random values for R/G/B.
PCL_EXPORTS void | getRandomColors (pcl::RGB &rgb, double min=0.2, double max=2.8)
| Get (good) random values for R/G/B.
PCL_EXPORTS Eigen::Matrix4d | vtkToEigen (vtkMatrix4x4 *vtk_matrix)
PCL_EXPORTS Eigen::Vector2i | worldToView (const Eigen::Vector4d &world_pt, const Eigen::Matrix4d &view_projection_matrix, int width, int height)
PCL_EXPORTS void | getViewFrustum (const Eigen::Matrix4d &view_projection_matrix, double planes[24])
PCL_EXPORTS int | cullFrustum (double planes[24], const Eigen::Vector3d &min_bb, const Eigen::Vector3d &max_bb)
PCL_EXPORTS float | viewScreenArea (const Eigen::Vector3d &eye, const Eigen::Vector3d &min_bb, const Eigen::Vector3d &max_bb, const Eigen::Matrix4d &view_projection_matrix, int width, int height)
PCL_EXPORTS bool | getColormapLUT (LookUpTableRepresentationProperties colormap_type, vtkSmartPointer< vtkLookupTable > &table)
| Generate a lookup table for a colormap.
template<typename PointT >
vtkSmartPointer< vtkDataSet > | createPolygon (const typename pcl::PointCloud< PointT >::ConstPtr &cloud)
| Create a 3d poly line from a set of points.
template<typename PointT >
vtkSmartPointer< vtkDataSet > | createPolygon (const pcl::PlanarPolygon< PointT > &planar_polygon)
| Create a 3d poly line from a set of points on the boundary of a planar region.
PCL_EXPORTS void | getCorrespondingPointCloud (vtkPolyData *src, const pcl::PointCloud< pcl::PointXYZ > &tgt, pcl::Indices &indices)
| Obtain a list of corresponding indices, for a set of vtk points, from a pcl::PointCloud.
PCL_EXPORTS bool | savePointData (vtkPolyData *data, const std::string &out_file, const CloudActorMapPtr &actors)
| Saves the vtk-formatted Point Cloud data into a set of files, based on whether the data comes from previously loaded PCD files.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createLine (const Eigen::Vector4f &pt1, const Eigen::Vector4f &pt2)
| Create a line shape from two points.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createSphere (const Eigen::Vector4f &center, double radius, int res=10)
| Create a sphere shape from a point and a radius.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createCylinder (const pcl::ModelCoefficients &coefficients, int numsides=30)
| Create a cylinder shape from a set of model coefficients.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createSphere (const pcl::ModelCoefficients &coefficients, int res=10)
| Create a sphere shape from a set of model coefficients.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createLine (const pcl::ModelCoefficients &coefficients)
| Create a line shape from a set of model coefficients.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createPlane (const pcl::ModelCoefficients &coefficients)
| Create a planar shape from a set of model coefficients.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createPlane (const pcl::ModelCoefficients &coefficients, double x, double y, double z)
| Create a planar shape from a set of model coefficients.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | create2DCircle (const pcl::ModelCoefficients &coefficients, double z=0.0)
| Create a 2d circle shape from a set of model coefficients.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createCone (const pcl::ModelCoefficients &coefficients)
| Create a cone shape from a set of model coefficients.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createCube (const pcl::ModelCoefficients &coefficients)
| Create a cube shape from a set of model coefficients.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createCube (const Eigen::Vector3f &translation, const Eigen::Quaternionf &rotation, double width, double height, double depth)
| Create a cube shape from a set of model coefficients.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createCube (double x_min, double x_max, double y_min, double y_max, double z_min, double z_max)
| Create a cube from a set of bounding points.
PCL_EXPORTS vtkSmartPointer< vtkDataSet > | createEllipsoid (const Eigen::Isometry3d &transform, double radius_x, double radius_y, double radius_z)
| Create an ellipsoid shape from the given parameters.
PCL_EXPORTS void | allocVtkUnstructuredGrid (vtkSmartPointer< vtkUnstructuredGrid > &polydata)
| Allocate a new unstructured grid smartpointer.
static const Vector3ub | green_color (0, 255, 0)
static const Vector3ub | red_color (255, 0, 0)
static const Vector3ub | blue_color (0, 0, 255)

## Typedef Documentation

## CloudActorMap

using pcl::visualization::CloudActorMap = typedef std::unordered_map<std::string, CloudActor>

Definition at line 96 of file actor_map.h.

## CloudActorMapPtr

using pcl::visualization::CloudActorMapPtr = typedef shared_ptr<CloudActorMap>

Definition at line 97 of file actor_map.h.

## CoordinateActorMap

using pcl::visualization::CoordinateActorMap = typedef std::unordered_map<std::string, vtkSmartPointer<vtkProp> >

Definition at line 102 of file actor_map.h.

## CoordinateActorMapPtr

using pcl::visualization::CoordinateActorMapPtr = typedef shared_ptr<CoordinateActorMap>

Definition at line 103 of file actor_map.h.

## RenWinInteractMap

using pcl::visualization::RenWinInteractMap = typedef std::map<std::string, RenWinInteract>

Definition at line 80 of file ren_win_interact_map.h.

## ShapeActorMap

using pcl::visualization::ShapeActorMap = typedef std::unordered_map<std::string, vtkSmartPointer<vtkProp> >

Definition at line 99 of file actor_map.h.

## ShapeActorMapPtr

using pcl::visualization::ShapeActorMapPtr = typedef shared_ptr<ShapeActorMap>

Definition at line 100 of file actor_map.h.

## Vector3ub

using pcl::visualization::Vector3ub = typedef Eigen::Array<unsigned char, 3, 1>

Definition at line 66 of file image_viewer.h.

## Enumeration Type Documentation

## FrustumCull

enum pcl::visualization::FrustumCull

Enumerator
PCL_INSIDE_FRUSTUM |
PCL_INTERSECT_FRUSTUM |
PCL_OUTSIDE_FRUSTUM |

Definition at line 87 of file common.h.

## InteractorKeyboardModifier

enum pcl::visualization::InteractorKeyboardModifier

A list of potential keyboard modifiers for pcl::visualization::PCLVisualizerInteractorStyle::PCLVisualizerInteractorStyle() Defaults to Alt.

Enumerator
INTERACTOR_KB_MOD_ALT |
INTERACTOR_KB_MOD_CTRL |
INTERACTOR_KB_MOD_SHIFT |

Definition at line 69 of file interactor_style.h.

## LookUpTableRepresentationProperties

enum pcl::visualization::LookUpTableRepresentationProperties

Colormap properties. See mathworks colormap page for image representations of the colormaps.

Enumerator
PCL_VISUALIZER_LUT_JET | Jet colormap.
PCL_VISUALIZER_LUT_JET_INVERSE | Inverse jet colormap.
PCL_VISUALIZER_LUT_HSV | HSV colormap.
PCL_VISUALIZER_LUT_HSV_INVERSE | Inverse HSV colormap.
PCL_VISUALIZER_LUT_GREY | Grey colormap (black to white)
PCL_VISUALIZER_LUT_BLUE2RED | Blue to red colormap (blue to white to red)
PCL_VISUALIZER_LUT_RANGE_AUTO | Set LUT range to min and max values of the data.
PCL_VISUALIZER_LUT_VIRIDIS | Viridis colormap.

Definition at line 130 of file common.h.

## RenderingProperties

enum pcl::visualization::RenderingProperties

Set of rendering properties.

Enumerator
PCL_VISUALIZER_POINT_SIZE | integer starting from 1
PCL_VISUALIZER_OPACITY | Float going from 0.0 (transparent) to 1.0 (opaque)
PCL_VISUALIZER_LINE_WIDTH | Integer starting from 1.
PCL_VISUALIZER_FONT_SIZE |
PCL_VISUALIZER_COLOR | 3 floats (R, G, B) going from 0.0 (dark) to 1.0 (light)
PCL_VISUALIZER_REPRESENTATION |
PCL_VISUALIZER_IMMEDIATE_RENDERING |
PCL_VISUALIZER_SHADING |
PCL_VISUALIZER_LUT | colormap type pcl::visualization::LookUpTableRepresentationProperties
PCL_VISUALIZER_LUT_RANGE | two doubles (min and max) or PCL_VISUALIZER_LUT_RANGE_AUTO

Definition at line 101 of file common.h.

## RenderingRepresentationProperties

enum pcl::visualization::RenderingRepresentationProperties

Enumerator
PCL_VISUALIZER_REPRESENTATION_POINTS |
PCL_VISUALIZER_REPRESENTATION_WIREFRAME |
PCL_VISUALIZER_REPRESENTATION_SURFACE |

Definition at line 115 of file common.h.

## ShadingRepresentationProperties

enum pcl::visualization::ShadingRepresentationProperties

Enumerator
PCL_VISUALIZER_SHADING_FLAT |
PCL_VISUALIZER_SHADING_GOURAUD |
PCL_VISUALIZER_SHADING_PHONG |

Definition at line 122 of file common.h.

## Function Documentation

## allocVtkUnstructuredGrid()

PCL_EXPORTS void pcl::visualization::allocVtkUnstructuredGrid | ( | vtkSmartPointer< vtkUnstructuredGrid > & | polydata | ) |

Allocate a new unstructured grid smartpointer.

For internal use only.

Parameters

  [out] | polydata | the resultant unstructured grid.

Referenced by pcl::visualization::PCLVisualizer::addPolygonMesh(), createPolygon(), and createPolygon().

## blue_color()

static const Vector3ub pcl::visualization::blue_color | ( | 0 | ,
|  | 0 | ,
|  | 255 |
| ) |  |

static

## createCube()

PCL_EXPORTS vtkSmartPointer< vtkDataSet > pcl::visualization::createCube | ( | double | x_min,
|  | double | x_max,
|  | double | y_min,
|  | double | y_max,
|  | double | z_min,
|  | double | z_max
| ) |  |

Create a cube from a set of bounding points.

Parameters

  [in] | x_min | is the minimum x value of the box
  [in] | x_max | is the maximum x value of the box
  [in] | y_min | is the minimum y value of the box
  [in] | y_max | is the maximum y value of the box
  [in] | z_min | is the minimum z value of the box
  [in] | z_max | is the maximum z value of the box

## cullFrustum()

PCL_EXPORTS int pcl::visualization::cullFrustum | ( | double | planes[24],
|  | const Eigen::Vector3d & | min_bb,
|  | const Eigen::Vector3d & | max_bb
| ) |  |

## getColormapLUT()

PCL_EXPORTS bool pcl::visualization::getColormapLUT | ( | LookUpTableRepresentationProperties | colormap_type,
|  | vtkSmartPointer< vtkLookupTable > & | table
| ) |  |

Generate a lookup table for a colormap.

Parameters

  [in] | colormap_type |
  [out] | table | a vtk lookup table

Note
  The list of available colormaps can be found in pcl::visualization::LookUpTableRepresentationProperties.

## getRandomColors() [1/2]

PCL_EXPORTS void pcl::visualization::getRandomColors | ( | double & | r,
|  | double & | g,
|  | double & | b,
|  | double | min = `0.2`,
|  | double | max = `2.8`
| ) |  |

Get (good) random values for R/G/B.

Parameters

  [out] | r | the resultant R color value
  [out] | g | the resultant G color value
  [out] | b | the resultant B color value
  [in] | min | minimum value for the colors
  [in] | max | maximum value for the colors

Referenced by pcl::visualization::PointCloudColorHandlerRandom< PointT >::getColor(), and pcl::visualization::ImageViewer::showCorrespondences().

## getRandomColors() [2/2]

PCL_EXPORTS void pcl::visualization::getRandomColors | ( | pcl::RGB & | rgb,
|  | double | min = `0.2`,
|  | double | max = `2.8`
| ) |  |

Get (good) random values for R/G/B.

Parameters

  [out] | rgb | the resultant RGB color value
  [in] | min | minimum value for the colors
  [in] | max | maximum value for the colors

## getViewFrustum()

PCL_EXPORTS void pcl::visualization::getViewFrustum | ( | const Eigen::Matrix4d & | view_projection_matrix,
|  | double | planes[24]
| ) |  |

## green_color()

static const Vector3ub pcl::visualization::green_color | ( | 0 | ,
|  | 255 | ,
|  | 0 |
| ) |  |

static

## red_color()

static const Vector3ub pcl::visualization::red_color | ( | 255 | ,
|  | 0 | ,
|  | 0 |
| ) |  |

static

## viewScreenArea()

PCL_EXPORTS float pcl::visualization::viewScreenArea | ( | const Eigen::Vector3d & | eye,
|  | const Eigen::Vector3d & | min_bb,
|  | const Eigen::Vector3d & | max_bb,
|  | const Eigen::Matrix4d & | view_projection_matrix,
|  | int | width,
|  | int | height
| ) |  |

Referenced by pcl::outofcore::OutofcoreOctreeBaseNode< ContainerT, PointT >::queryFrustum().

## vtkToEigen()

PCL_EXPORTS Eigen::Matrix4d pcl::visualization::vtkToEigen | ( | vtkMatrix4x4 * | vtk_matrix | ) |

## worldToView()

PCL_EXPORTS Eigen::Vector2i pcl::visualization::worldToView | ( | const Eigen::Vector4d & | world_pt,
|  | const Eigen::Matrix4d & | view_projection_matrix,
|  | int | width,
|  | int | height
| ) |  |